module Microservice
  class OmniauthCallbacksController < ::Microservice::ApplicationController

    def sso
      @user = User.find_or_initialize_by(uuid: request.env['omniauth.auth']['uid'])

      update_user_from_omniauth(request.env['omniauth.auth'])

      if @user.new_record?
        @user.password = Devise.friendly_token[0, 20]
        @user.skip_confirmation!
      end

      if @user.save
        flash[:notice] = t('devise.omniauth_callbacks.success', kind: 'SSO')
        sign_in_and_redirect @user, event: :authentication
      else
        Rails.logger.error @user.errors.full_messages
        redirect_to root_url, alert: t(:notice_cannot_create_account)
      end
    end

    protected

    def update_user_from_omniauth(omniauth_attrs)
      @user.first_name = omniauth_attrs['info']['first_name']
      @user.last_name = omniauth_attrs['info']['last_name']
      @user.username = omniauth_attrs['info']['username']
      @user.name = omniauth_attrs['info']['name']
      @user.email = omniauth_attrs['info']['email']
      @user.image = omniauth_attrs['info']['image']
      @user.status = omniauth_attrs['info']['status']
    end

  end
end
