module Microservice
  module Concerns
    module EntityMovable
      extend ActiveSupport::Concern

      included do

        after_save :do_move, if: -> {self.move_attributes.present?}

        attr_accessor :move_attributes

      end

      protected

      def do_move
      end

      def create_target_entity_from(move_to_params)
        return nil if move_to_params.blank?

        move_to_params['target_class'].constantize.find(move_to_params['target_id'])
      end

    end
  end
end
