module Microservice
  module Concerns
    module EntityNaming
      extend ActiveSupport::Concern

      included do
      end

      class_methods do

        def heading_index
          I18n.t(:heading_entity_index, entities: self.base_class.model_name.plural.humanize)
        end

        def button_index
          I18n.t(:button_entity_index, entities: self.base_class.model_name.plural.humanize)
        end

        def title_index
          I18n.t(:title_entity_index, entities: self.base_class.model_name.plural)
        end

        def heading_show
          self.model_name.human
        end

        def heading_new
          I18n.t(:heading_entity_new, entity: self.model_name.human)
        end

        def button_new
          I18n.t(:button_entity_new, entity: self.model_name.human)
        end

        def title_new
          I18n.t(:title_entity_new, entity: self.model_name.human)
        end

      end

      def heading_index
        self.class.heading_index
      end

      def button_index
        self.class.button_index
      end

      def title_index
        self.class.title_index
      end

      def heading_show
        I18n.t(:heading_entity_show, entity: self.name)
      end

      def button_show
        name
      end

      def title_show
        I18n.t(:title_entity_show, entity: self.name)
      end

      def heading_new
        self.class.heading_new
      end

      def button_new
        self.class.button_new
      end

      def title_new
        self.class.title_new
      end

      def heading_edit
        I18n.t(:heading_entity_edit, entity: self.class.model_name.human)
      end

      def button_edit
        I18n.t(:button_entity_edit, entity: self.class.model_name.human)
      end

      def title_edit
        I18n.t(:title_entity_edit, entity: self.name)
      end

      def title_delete
        I18n.t(:title_entity_delete, entity: self.name)
      end

    end
  end
end
