module Microservice
  module Concerns
    module UserModel
      extend ActiveSupport::Concern

      included do

        enum status: [:active]

        devise :database_authenticatable, :trackable, :validatable,
               :registerable, :recoverable, :rememberable, :confirmable, :lockable, :timeoutable,
               :token_authenticatable,
               :omniauthable, omniauth_providers: Microservice::Settings.omniauth_providers_keys

        scope :admins, -> {where(admin: true)}

        store :preferences, coder: JSON

        thread_mattr_accessor :current

        before_save :ensure_name

      end

      class_methods do
      end

      protected

      def ensure_name
        self.name = "#{first_name} #{last_name}"
      end

    end
  end
end
