class CreateUsers < ActiveRecord::Migration[5.1]
  def change
    create_table :users, force: true do |t|
      t.string :first_name
      t.string :last_name
      t.string :name
      t.string :username
      t.integer :status, default: 0
      t.date :expiration_date
      t.string :image
      t.boolean :admin, default: false
      t.string :uuid, unique: true

      t.text :preferences

      t.string :authentication_token, index: true
      t.datetime :authentication_token_created_at

      ## Database authenticatable
      t.string :email, null: false, default: '', unique: true
      t.string :encrypted_password, null: false, default: ''

      ## Recoverable
      t.string :reset_password_token, unique: true
      t.datetime :reset_password_sent_at

      ## Rememberable
      t.datetime :remember_created_at

      ## Trackable
      t.integer :sign_in_count, default: 0, null: false
      t.datetime :current_sign_in_at
      t.datetime :last_sign_in_at
      t.string :current_sign_in_ip
      t.string :last_sign_in_ip

      ## Confirmable
      t.string :confirmation_token, unique: true
      t.datetime :confirmed_at
      t.datetime :confirmation_sent_at
      t.string :unconfirmed_email # Only if using reconfirmable

      ## Lockable
      t.integer :failed_attempts, default: 0, null: false # Only if lock strategy is :failed_attempts
      t.string :unlock_token, unique: true # Only if unlock strategy is :email or :both
      t.datetime :locked_at

      t.timestamps null: false
    end
  end
end
