module Microservice
  class Settings

    class << self

      def all
        Rails.application.secrets
      end

      def application_name
        all[:application_name] || 'Microservice Application'
      end

      def email_default_from
        all[:email_default_from]
      end

      def host_name
        all[:host_name] || 'localhost'
      end

      def protocol
        all[:protocol] || 'http'
      end

      def host
        "#{protocol}://#{host_name}"
      end

      def uuid_prefix
        all[:uuid_prefix] || 'micro'
      end

      def omniauth_providers
        all[:omniauth_providers] || {}
      end

      def omniauth_providers_keys
        omniauth_providers.keys
      end

      def omniauth_provider_path(provider)
        if opts = omniauth_providers[provider]
          url = "/users/auth/#{provider}"

          x = []
          x << "auth_provider=#{opts[:auth_provider]}" if opts[:auth_provider]
          x << "auth_url=#{opts[:auth_url]}" if opts[:auth_url]

          if x.present?
            url += '?' + x.join('&')
          end

          url
        else
          ''
        end
      end

    end
  end
end
